diff --git a/web/.eslintrc.js b/web/.eslintrc.js
index 9b75cd809..ce89c7b0e 100644
--- a/web/.eslintrc.js
+++ b/web/.eslintrc.js
@@ -18,16 +18,23 @@ module.exports = {
     'eslint:recommended',
     'plugin:react/recommended',
   ],
-  'parser': 'babel-eslint',
+  'parser': '@babel/eslint-parser',
   'parserOptions': {
+    'requireConfigFile': false,
     'ecmaVersion': 2018,
     'ecmaFeatures': {
-      'jsx': true
+      'jsx': true,
     },
     'sourceType': 'module',
+    'babelOptions': {
+      'plugins': [
+        '@babel/plugin-syntax-jsx',
+      ],
+    },
   },
   'plugins': [
-    'react'
+    'react',
+    '@babel',
   ],
   'globals': {
     '_': true,
@@ -36,28 +43,31 @@ module.exports = {
   'rules': {
     'indent': [
       'error',
-      2
+      2,
     ],
     'linebreak-style': 0,
     'quotes': [
       'error',
-      'single'
+      'single',
     ],
     'semi': [
       'error',
-      'always'
+      'always',
     ],
     'comma-dangle': [
       'error',
-      'always-multiline'
+      'only-multiline',
     ],
-    'no-console': ["error", { allow: ["warn", "error"] }],
+    'no-console': ['error', { allow: ['warn', 'error'] }],
     // We need to exclude below for RegEx case
-    "no-useless-escape": 0,
+    'no-useless-escape': 0,
+    'no-prototype-builtins': 0,
+    'no-global-assign': 0,
+    'no-import-assign': 0,
   },
   'settings': {
     'react': {
       'version': 'detect',
     },
-  }
+  },
 };
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/static/js/foreign_key.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/static/js/foreign_key.js
index 03effb67e..6819025a5 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/static/js/foreign_key.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/static/js/foreign_key.js
@@ -920,7 +920,7 @@ define('pgadmin.node.foreign_key', [
               self.listenTo(collection, 'remove', self.render);
             },
             formatter: {
-              fromRaw: function (rawValue,model,) {
+              fromRaw: function (rawValue,model) {
                 var remote_tables = [],
                   m = model.get('columns');
                 if (m.length > 0) {
diff --git a/web/pgadmin/browser/static/js/collection.js b/web/pgadmin/browser/static/js/collection.js
index d412d67ad..14020af78 100644
--- a/web/pgadmin/browser/static/js/collection.js
+++ b/web/pgadmin/browser/static/js/collection.js
@@ -54,7 +54,7 @@ define([
               name: 'show_query_tool', node: this.type, module: this,
               applies: ['context'], callback: 'show_query_tool',
               priority: 998, label: gettext('Query Tool'),
-              icon: 'pg-font-icon icon-query-tool',
+              icon: 'pg-font-icon icon-query_tool',
             }]);
 
             // show search objects same as query tool
@@ -261,7 +261,7 @@ define([
           type: 'delete',
           tooltip: gettext('Drop Cascade'),
           extraClasses: ['btn-primary-icon m-1', 'delete_multiple_cascade'],
-          icon: 'pg-font-icon icon-drop-cascade',
+          icon: 'pg-font-icon icon-drop_cascade',
           disabled: (_.isFunction(that.canDropCascade)) ? !(that.canDropCascade.apply(self, [data, item])) : (!that.canDropCascade),
           register: function(btn) {
             btn.on('click',() => {
diff --git a/web/pgadmin/browser/static/js/node.js b/web/pgadmin/browser/static/js/node.js
index 201dfbfcf..7c2f666e0 100644
--- a/web/pgadmin/browser/static/js/node.js
+++ b/web/pgadmin/browser/static/js/node.js
@@ -198,7 +198,7 @@ define('pgadmin.browser.node', [
           callback: 'show_query_tool',
           priority: 998,
           label: gettext('Query Tool'),
-          icon: 'pg-font-icon icon-query-tool',
+          icon: 'pg-font-icon icon-query_tool',
           enable: enable,
         }]);
 
diff --git a/web/pgadmin/browser/static/js/preferences.js b/web/pgadmin/browser/static/js/preferences.js
index f63406cba..c5eafacd2 100644
--- a/web/pgadmin/browser/static/js/preferences.js
+++ b/web/pgadmin/browser/static/js/preferences.js
@@ -47,23 +47,10 @@ _.extend(pgBrowser, {
   /* Get cached preference */
   get_preference: function(module, preference){
     const self = this;
-    // If cache is not yet loaded then keep checking
-    if(_.size(self.preferences_cache) == 0) {
-      var check_preference = function() {
-          if(self.preferences_cache.length > 0) {
-            clearInterval(preferenceTimeout);
-            return _.findWhere(
-              self.preferences_cache, {'module': module, 'name': preference}
-            );
-          }
-        },
-        preferenceTimeout = setInterval(check_preference, 1000);
-    }
-    else {
-      return _.findWhere(
-        self.preferences_cache, {'module': module, 'name': preference}
-      );
-    }
+
+    return _.findWhere(
+      self.preferences_cache, {'module': module, 'name': preference}
+    );
   },
 
   /* Get all the preferences of a module */
diff --git a/web/pgadmin/browser/static/js/toolbar.js b/web/pgadmin/browser/static/js/toolbar.js
index 3703ccc6d..09baaf228 100644
--- a/web/pgadmin/browser/static/js/toolbar.js
+++ b/web/pgadmin/browser/static/js/toolbar.js
@@ -20,7 +20,7 @@ let _defaultToolBarButtons = [
   {
     label: gettext('Query Tool'),
     ariaLabel: gettext('Query Tool'),
-    btnClass: 'pg-font-icon icon-query-tool',
+    btnClass: 'pg-font-icon icon-query_tool',
     text: '',
     toggled: false,
     toggleClass: '',
@@ -30,7 +30,7 @@ let _defaultToolBarButtons = [
   {
     label: gettext('View Data'),
     ariaLabel: gettext('View Data'),
-    btnClass: 'pg-font-icon sql-icon-lg icon-view-data',
+    btnClass: 'pg-font-icon sql-icon-lg icon-view_data',
     text: '',
     toggled: false,
     toggleClass: '',
@@ -40,7 +40,7 @@ let _defaultToolBarButtons = [
   {
     label: gettext('Filtered Rows'),
     ariaLabel: gettext('Filtered Rows'),
-    btnClass: 'pg-font-icon icon-filter-table-toolbar',
+    btnClass: 'pg-font-icon icon-row_filter',
     text: '',
     toggled: false,
     toggleClass: '',
diff --git a/web/pgadmin/feature_tests/query_tool_journey_test.py b/web/pgadmin/feature_tests/query_tool_journey_test.py
index 59c0aa940..4ec636302 100644
--- a/web/pgadmin/feature_tests/query_tool_journey_test.py
+++ b/web/pgadmin/feature_tests/query_tool_journey_test.py
@@ -373,7 +373,7 @@ class QueryToolJourneyTest(BaseFeatureTest):
             icon_classes = query_history_selected_icon.get_attribute('class')
             icon_classes = icon_classes.split(" ")
             self.assertTrue(
-                icon in icon_classes or 'icon-save-data-changes' in
+                icon in icon_classes or 'icon-save_data_changes' in
                 icon_classes or 'icon-commit' in icon_classes or
                 'fa-play' in icon_classes)
             # Move to next entry
diff --git a/web/pgadmin/misc/bgprocess/static/js/bgprocess.js b/web/pgadmin/misc/bgprocess/static/js/bgprocess.js
index cbd8ecde6..fa3bf9480 100644
--- a/web/pgadmin/misc/bgprocess/static/js/bgprocess.js
+++ b/web/pgadmin/misc/bgprocess/static/js/bgprocess.js
@@ -428,7 +428,7 @@ define('misc.bgprocess', [
         if(self.current_storage_dir && isServerMode) { //for backup & exports with server mode, operate over storage manager
 
           if($btn_storage_manager.length == 0) {
-            var str_storage_manager_btn = '<button id="bg-process-storage-manager" class="btn btn-secondary bg-process-storage-manager" title="Click to open file location" aria-label="Storage Manager" tabindex="0" disabled><span class="pg-font-icon icon-storage-manager" role="img"></span></button>&nbsp;';
+            var str_storage_manager_btn = '<button id="bg-process-storage-manager" class="btn btn-secondary bg-process-storage-manager" title="Click to open file location" aria-label="Storage Manager" tabindex="0" disabled><span class="pg-font-icon icon-storage_manager" role="img"></span></button>&nbsp;';
             container.find('.bg-process-details .bg-btn-section').prepend(str_storage_manager_btn);
             $btn_storage_manager = container.find('.bg-process-storage-manager');
           }
diff --git a/web/pgadmin/misc/static/explain/js/explain.js b/web/pgadmin/misc/static/explain/js/explain.js
index 48ac1d567..75a8220a8 100644
--- a/web/pgadmin/misc/static/explain/js/explain.js
+++ b/web/pgadmin/misc/static/explain/js/explain.js
@@ -1209,8 +1209,8 @@ define('pgadmin.misc.explain', [
     // Assumption container is a jQuery object
     DrawJSONPlan: function(container, plan, isDownload, _ctx) {
       let self = this;
-      require.ensure(['snapsvg'], function(require) {
-        var module = require('snapsvg');
+      require.ensure(['snap.svg'], function(require) {
+        var module = require('snap.svg');
         initSnap(module);
         self.goForDraw(container, plan, isDownload, _ctx);
       }, function(error){
diff --git a/web/pgadmin/static/js/browser/server_groups/servers/model_validation.js b/web/pgadmin/static/js/browser/server_groups/servers/model_validation.js
index d542aa072..b95d578f4 100644
--- a/web/pgadmin/static/js/browser/server_groups/servers/model_validation.js
+++ b/web/pgadmin/static/js/browser/server_groups/servers/model_validation.js
@@ -113,11 +113,15 @@ export class ModelValidation {
 
   checkForValidIp(ipAddress, msg) {
     if (ipAddress) {
-      const isIpv6Address = new Address6(ipAddress).isValid();
-      const isIpv4Address = new Address4(ipAddress).isValid();
-      if (!isIpv4Address && !isIpv6Address) {
-        this.err['hostaddr'] = msg;
-        this.errmsg = msg;
+      try {
+        new Address4(ipAddress);
+      } catch(e) {
+        try {
+          new Address6(ipAddress);
+        } catch(e) {
+          this.err['hostaddr'] = msg;
+          this.errmsg = msg;
+        }
       }
     } else {
       this.model.errorModel.unset('hostaddr');
diff --git a/web/pgadmin/static/js/pgadmin.fonticon.js b/web/pgadmin/static/js/pgadmin.fonticon.js
new file mode 100644
index 000000000..a47f21c5c
--- /dev/null
+++ b/web/pgadmin/static/js/pgadmin.fonticon.js
@@ -0,0 +1,11 @@
+module.exports = {
+  'files': [
+    '../img/fonticon/*.svg',
+  ],
+  'css': false,
+  'fontName': 'pgfonticon',
+  'classPrefix': 'icon-',
+  'baseSelector': '.pg-font-icon',
+  'types': ['eot', 'woff', 'woff2', 'ttf', 'svg'],
+  'embed': true,
+};
diff --git a/web/pgadmin/static/js/sqleditor/history/query_sources.js b/web/pgadmin/static/js/sqleditor/history/query_sources.js
index 43960e05c..5e28c351a 100644
--- a/web/pgadmin/static/js/sqleditor/history/query_sources.js
+++ b/web/pgadmin/static/js/sqleditor/history/query_sources.js
@@ -21,15 +21,15 @@ export const QuerySources = {
     ICON_CSS_CLASS: 'fa fa-list-alt',
   },
   COMMIT: {
-    ICON_CSS_CLASS: 'icon-commit',
+    ICON_CSS_CLASS: 'pg-font-icon icon-commit',
   },
   ROLLBACK: {
-    ICON_CSS_CLASS: 'icon-rollback',
+    ICON_CSS_CLASS: 'pg-font-icon icon-rollback',
   },
   SAVE_DATA: {
-    ICON_CSS_CLASS: 'icon-save-data-changes',
+    ICON_CSS_CLASS: 'pg-font-icon icon-save_data_changes',
   },
   VIEW_DATA: {
-    ICON_CSS_CLASS: 'icon-view-data',
+    ICON_CSS_CLASS: 'pg-font-icon picon-view_data',
   },
 };
diff --git a/web/pgadmin/static/js/sqleditor_utils.js b/web/pgadmin/static/js/sqleditor_utils.js
index 6aa58a3d7..5f5b149e0 100644
--- a/web/pgadmin/static/js/sqleditor_utils.js
+++ b/web/pgadmin/static/js/sqleditor_utils.js
@@ -135,7 +135,7 @@ define(['jquery', 'underscore', 'sources/gettext', 'sources/url_for'],
                 if(sqlEditorUtils.previousStatus != status &&
                         !$status_el.hasClass('fa-query_tool_connected')) {
                   $status_el.removeClass()
-                    .addClass('pg-font-icon icon-query-tool-connected');
+                    .addClass('pg-font-icon icon-connected');
                   is_status_changed = true;
                 }
               }
@@ -153,10 +153,10 @@ define(['jquery', 'underscore', 'sources/gettext', 'sources/url_for'],
               msg = gettext('An unexpected error occurred - ' +
                           'ensure you are logged into the application.');
               $el.attr('data-content', msg);
-              if(!$status_el.hasClass('icon-query-tool-disconnected')) {
+              if(!$status_el.hasClass('icon-disconnected')) {
                 $el.popover('hide');
                 $status_el.removeClass()
-                  .addClass('pg-icon-font icon-query-tool-disconnected');
+                  .addClass('pg-icon-font icon-disconnected');
               }
             }
           })
@@ -173,10 +173,10 @@ define(['jquery', 'underscore', 'sources/gettext', 'sources/url_for'],
             // Set bootstrap popover
             $el.attr('data-content', msg);
             // Add error class
-            if(!$status_el.hasClass('icon-query-tool-disconnected')) {
+            if(!$status_el.hasClass('icon-disconnected')) {
               $el.popover('hide');
               $status_el.removeClass()
-                .addClass('pg-font-icon icon-query-tool-disconnected');
+                .addClass('pg-font-icon icon-disconnected');
             }
           });
       },
diff --git a/web/pgadmin/tools/datagrid/static/js/datagrid.js b/web/pgadmin/tools/datagrid/static/js/datagrid.js
index adc6651bf..a4f2cf648 100644
--- a/web/pgadmin/tools/datagrid/static/js/datagrid.js
+++ b/web/pgadmin/tools/datagrid/static/js/datagrid.js
@@ -112,7 +112,7 @@ define('pgadmin.datagrid', [
           enable: query_tool_menu_enabled,
           priority: 1,
           label: gettext('Query Tool'),
-          icon: 'pg-font-icon icon-query-tool',
+          icon: 'pg-font-icon icon-query_tool',
           data:{
             data_disabled: gettext('Please select a database from the browser tree to access Query Tool.'),
           },
diff --git a/web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js b/web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js
index b3bd793e0..2f7d0eaee 100644
--- a/web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js
+++ b/web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js
@@ -64,11 +64,11 @@ export function setQueryToolDockerTitle(panel, is_query_tool, panel_title, is_fi
   else if (is_query_tool == 'false' || is_query_tool == false) {
     // Edit grid titles
     panel_tooltip = gettext('View/Edit Data - ') + panel_title;
-    panel_icon = 'pg-font-icon icon-view-data';
+    panel_icon = 'pg-font-icon icon-view_data';
   } else {
     // Query tool titles
     panel_tooltip = gettext('Query Tool - ') + panel_title;
-    panel_icon = 'pg-font-icon icon-query-tool';
+    panel_icon = 'pg-font-icon icon-query_tool';
   }
 
   panel.title('<span title="'+ _.escape(panel_tooltip) +'">'+ _.escape(panel_title) +'</span>');
diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/ui_components/ConnectionBar.jsx b/web/pgadmin/tools/erd/static/js/erd_tool/ui_components/ConnectionBar.jsx
index 3b71dbcc0..7aae1a216 100644
--- a/web/pgadmin/tools/erd/static/js/erd_tool/ui_components/ConnectionBar.jsx
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/ui_components/ConnectionBar.jsx
@@ -30,8 +30,8 @@ export default function ConnectionBar({statusId, status, bgcolor, fgcolor, title
         data-panel-visible="visible"
         tabIndex="0">
         <span className={'pg-font-icon d-flex m-auto '
-            + (status == STATUS.CONNECTED ? 'icon-query-tool-connected' : '')
-            + (status == (STATUS.DISCONNECTED || STATUS.FAILED) ? 'icon-query-tool-disconnected ' : '')
+            + (status == STATUS.CONNECTED ? 'icon-connected' : '')
+            + (status == (STATUS.DISCONNECTED || STATUS.FAILED) ? 'icon-disconnected ' : '')
             + (status == STATUS.CONNECTING ? 'obtaining-conn' : '')}
         aria-hidden="true" title="" role="img">
         </span>
diff --git a/web/pgadmin/tools/schema_diff/static/js/schema_diff.backform.js b/web/pgadmin/tools/schema_diff/static/js/schema_diff.backform.js
index cb704e168..316d98d94 100644
--- a/web/pgadmin/tools/schema_diff/static/js/schema_diff.backform.js
+++ b/web/pgadmin/tools/schema_diff/static/js/schema_diff.backform.js
@@ -59,7 +59,7 @@ let SchemaDiffSqlControl =
       Backform.TextareaControl.prototype.initialize.apply(this, arguments);
       this.sqlCtrl = null;
 
-      _.bindAll(this, 'onFocus', 'onBlur', 'refreshTextArea', 'copyData',);
+      _.bindAll(this, 'onFocus', 'onBlur', 'refreshTextArea', 'copyData');
     },
     render: function() {
       let obj = Backform.SqlFieldControl.prototype.render.apply(this, arguments);
@@ -317,7 +317,7 @@ let SchemaDiffHeaderView = Backform.Form.extend({
       <div class="col-6 target row"></div>
       <div class="col-5 target-buttons">
           <div class="action-btns d-flex">
-              <button class="btn btn-primary mr-auto"><span class="pg-font-icon icon-schema-diff sql-icon-lg"></span>&nbsp;` + gettext('Compare') + `</button>
+              <button class="btn btn-primary mr-auto"><span class="pg-font-icon icon-compare sql-icon-lg"></span>&nbsp;` + gettext('Compare') + `</button>
               <button id="generate-script" class="btn btn-primary-icon mr-1" disabled><i class="fa fa-file-code sql-icon-lg"></i>&nbsp;` + gettext('Generate Script') + `</button>
               <div class="btn-group mr-1" role="group" aria-label="">
                 <button id="btn-filter" type="button" class="btn btn-primary-icon"
diff --git a/web/pgadmin/tools/schema_diff/static/js/schema_diff.js b/web/pgadmin/tools/schema_diff/static/js/schema_diff.js
index 1f1ef7ffb..25258d538 100644
--- a/web/pgadmin/tools/schema_diff/static/js/schema_diff.js
+++ b/web/pgadmin/tools/schema_diff/static/js/schema_diff.js
@@ -134,7 +134,7 @@ define('pgadmin.schemadiff', [
 
         // Set panel title and icon
         schemaDiffPanel.title('<span title="'+panel_tooltip+'">'+panel_title+'</span>');
-        schemaDiffPanel.icon('pg-font-icon icon-schema-diff');
+        schemaDiffPanel.icon('pg-font-icon icon-compare');
         schemaDiffPanel.focus();
 
         var openSchemaDiffURL = function(j) {
diff --git a/web/pgadmin/tools/sqleditor/static/js/sqleditor.js b/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
index 21cb4c880..cdd4fce72 100644
--- a/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
+++ b/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
@@ -6,6 +6,10 @@
 // This software is released under the PostgreSQL Licence
 //
 //////////////////////////////////////////////////////////////
+/* This is used to change publicPath of webpack at runtime for loading chunks */
+/* eslint-disable */
+__webpack_public_path__ = window.resourceBasePath;
+/* eslint-enable */
 
 import {launchDataGrid} from 'tools/datagrid/static/js/show_query_tool';
 
diff --git a/web/regression/javascript/search_objects/search_objects_dialog_spec.js b/web/regression/javascript/search_objects/search_objects_dialog_spec.js
index b47a5024d..70b6e8323 100644
--- a/web/regression/javascript/search_objects/search_objects_dialog_spec.js
+++ b/web/regression/javascript/search_objects/search_objects_dialog_spec.js
@@ -10,7 +10,6 @@ import SearchObjectsDialog from 'tools/search_objects/static/js/search_objects_d
 import {TreeFake} from '../tree/tree_fake';
 import MockAdapter from 'axios-mock-adapter';
 import axios from 'axios/index';
-import {pgBrowser} from 'pgadmin.browser.preferences';
 
 const context = describe;
 
@@ -28,6 +27,7 @@ describe('SearchObjectsDialog', () => {
   let soDialog;
   let jquerySpy;
   let alertifySpy;
+  let pgBrowser = {};
 
   beforeEach(() => {
     pgBrowser.preferences_cache = dummy_cache;
@@ -124,6 +124,10 @@ describe('SearchObjectsDialog', () => {
       );
 
       pgBrowser.get_preference = jasmine.createSpy('get_preferences');
+      pgBrowser.get_preferences_for_module =
+        jasmine.createSpy('get_preferences_for_module').and.returnValue({
+          [dummy_cache[0]['name']]: dummy_cache[0]['value'],
+        });
     });
 
     afterEach(() => {
